clang-tools 3.8.0

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
clang::tidy::ProBoundsConstantArrayIndexCheck Class Reference

This checks that all array subscriptions on static arrays and std::arrays have a constant index and are within bounds. More...

`#include <ProBoundsConstantArrayIndexCheck.h>`

Inheritance diagram for clang::tidy::ProBoundsConstantArrayIndexCheck:
[legend]
Collaboration diagram for clang::tidy::ProBoundsConstantArrayIndexCheck:
[legend]

## Public Member Functions
| ProBoundsConstantArrayIndexCheck (StringRef Name, ClangTidyContext *Context)
void | registerPPCallbacks (CompilerInstance &Compiler) override
| Override this to register `PPCallbacks` with `Compiler`. More...
void | registerMatchers (ast_matchers::MatchFinder *Finder) override
| Override this to register ASTMatchers with `Finder`. More...
void | storeOptions (ClangTidyOptions::OptionMap &Opts) override
| Should store all options supported by this check with their current values or default values for options that haven't been overridden. More...
void | check (const ast_matchers::MatchFinder::MatchResult &Result) override
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
LangOptions | getLangOpts () const
| Returns the language options from the context. More...
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options

## Detailed Description

This checks that all array subscriptions on static arrays and std::arrays have a constant index and are within bounds.

For the user-facing documentation see: http://clang.llvm.org/extra/clang-tidy/checks/cppcoreguidelines-pro-bounds-constant-array-index.html

Definition at line 24 of file ProBoundsConstantArrayIndexCheck.h.

## Constructor & Destructor Documentation

clang::tidy::ProBoundsConstantArrayIndexCheck::ProBoundsConstantArrayIndexCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |

Definition at line 21 of file ProBoundsConstantArrayIndexCheck.cpp.

## Member Function Documentation

void clang::tidy::ProBoundsConstantArrayIndexCheck::check | ( | const ast_matchers::MatchFinder::MatchResult & | Result | ) |
| override virtual

`ClangTidyChecks` that register ASTMatchers should do the actual work in here.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 63 of file ProBoundsConstantArrayIndexCheck.cpp.

References clang::tidy::ClangTidyCheck::diag().

void clang::tidy::ProBoundsConstantArrayIndexCheck::registerMatchers | ( | ast_matchers::MatchFinder * | Finder | ) |
| override virtual

Override this to register ASTMatchers with `Finder`.

This should be used by clang-tidy checks that analyze code properties that dependent on AST knowledge.

You can register as many matchers as necessary with `Finder`. Usually, "this" will be used as callback, but you can also specify other callback classes. Thereby, different matchers can trigger different callbacks.

If you need to merge information between the different matchers, you can store these as members of the derived class. However, note that all matches occur in the order of the AST traversal.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 43 of file ProBoundsConstantArrayIndexCheck.cpp.

References clang::tidy::ClangTidyCheck::getLangOpts().

void clang::tidy::ProBoundsConstantArrayIndexCheck::registerPPCallbacks | ( | CompilerInstance & | Compiler | ) |
| override virtual

Override this to register `PPCallbacks` with `Compiler`.

This should be used for clang-tidy checks that analyze preprocessor- dependent properties, e.g. the order of include directives.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 33 of file ProBoundsConstantArrayIndexCheck.cpp.

References clang::tidy::ClangTidyCheck::getLangOpts().

void clang::tidy::ProBoundsConstantArrayIndexCheck::storeOptions | ( | ClangTidyOptions::OptionMap & | Options | ) |
| override virtual

Should store all options supported by this check with their current values or default values for options that haven't been overridden.

The check should use `Options.store()` to store each option it supports whether it has the default value or it has been overridden.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 27 of file ProBoundsConstantArrayIndexCheck.cpp.

References clang::tidy::ClangTidyCheck::Options, and clang::tidy::OptionsView::store().

The documentation for this class was generated from the following files:

- ProBoundsConstantArrayIndexCheck.h
- ProBoundsConstantArrayIndexCheck.cpp